# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/07_strs.ipynb.

# %% auto 0
__all__ = ['dotstr', 'pkgstr', 'modstr', 'dostar']

# %% ../nbs/07_strs.ipynb 6
import copy, inspect
from inspect import ismethod
from inspect import Signature, Parameter, FullArgSpec, getfullargspec, signature, _empty as Empty, ismethod
from importlib import import_module
from itertools import chain, zip_longest
from functools import wraps, partial

# %% ../nbs/07_strs.ipynb 8
from types import ModuleType
from typing import Any, Union, Tuple, Callable, Iterable, TypeAlias, ParamSpec, Sequence

# %% ../nbs/07_strs.ipynb 10
#| export


# %% ../nbs/07_strs.ipynb 12
from atyp import AnyQ, IntQ, BoolQ, CallQ, DictQ, TupleQ, Bool01, BoolFunc, CallQ
from nchr import U1, DOT
from nlit import __ALL__, __DOC__,  __NAME__, __MODULE__,  INPLACE
from chck import isany, isdict, istuple, isnone, notnone, isditer, isrange
from idfunc import idfunc

# %% ../nbs/07_strs.ipynb 14
from .atyp import P, VArgs
from .args import getbound
from .util import filtdict
from .tups import pack, argtup
from .itrs import fallback

# %% ../nbs/07_strs.ipynb 16
def dotstr(*strs) -> str: return DOT.join(strs)

def pkgstr(*strs) -> str: 
    return dotstr(*argtup(*strs))

def modstr(lib:str, *pkgs: str): 
    return pkgstr(lib, *argtup(*pkgs))

def dostar(v: str) -> bool:
    return (not v.startswith(U1) or v.isupper())
